/***************************************************************************
                          login_dlg.cpp  -  description
                             -------------------
    begin                : Wed Aug 29 2001 by Tim Colgate
    copyright            : (C) 2001 Tim Colgate
    
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *

 ***************************************************************************/

#include <iostream>
#include <string>
using namespace std ;

#include <stdlib.h>	// getenv

#include <qmessagebox.h>
#include <qtooltip.h>

#include "login_dlg.h"


LoginDlg::LoginDlg(QWidget* parent, const QString& server_, const QString& database_, string& username_, string& password_, map<string, string>& logins_)
	: QDialog(parent, NULL, true),
	server(server_), database(database_), username(username_), password(password_), logins(logins_)
{
	bool db = !database.isEmpty();

	this->resize(320, 230);
	this->setCaption("Login details");
	
	QString s = "Enter login details for " + server;
	if (db)
		s += "." + database;
	lblMain = new QLabel(s, this);
	lblMain->setGeometry(10, 10, 300, 25);

	lblUsername = new QLabel("username", this);
	lblUsername->setGeometry(10, 50, 90, 25);
	lblPassword = new QLabel("password", this);
	lblPassword->setGeometry(10, 80, 90, 25);

	edtUsername = new QLineEdit(username.c_str(), this);
	edtUsername->setGeometry(100, 50, 200, 25);
	edtUsername->setFocus();
	edtPassword = new QLineEdit(password.c_str(), this);
	edtPassword->setGeometry(100, 80, 200, 25);

	chkDatabase = new QCheckBox("make default for all databases on this server", this);
	chkDatabase->setGeometry(10, 120, 300, 25);
	chkDatabase->setChecked(!db);
	QToolTip::add(chkDatabase, "Set this to make username and password default for all databases on this server, except where explicitly set differently");
	if (!db) chkDatabase->setEnabled(false);

	chkServer = new QCheckBox("make default for all servers", this);
	chkServer->setGeometry(10, 150, 300, 25);
	chkServer->setChecked(false);
	QToolTip::add(chkServer, "Set this to make username and password default for all Sybase servers");

	btnCancel = new QPushButton("Cancel", this);
	btnCancel->setGeometry(80, 190, 100, 30);
	
	btnExec = new QPushButton("Ok", this);
	btnExec->setGeometry(210, 190, 100, 30);
	btnExec->setDefault(true);
	
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnExec, SIGNAL(clicked()), this, SLOT(ok_pressed()));
}

void LoginDlg::ok_pressed()
{
	username = edtUsername->text();
	password = edtPassword->text();

	string t = username;
	t += '\t';
	t += password;

	if (!database.isEmpty()) {
		string s = (const char*)server;
		s += '.';
		s += (const char*)database;
		logins[s] = t;
	}
	if (chkDatabase->isChecked()) logins[(const char*)server] = t;
	if (chkServer->isChecked()) logins["*"] = t;
	
	accept();
}
