/***************************************************************************
                          login_dlg.h  -  description
                             -------------------
    begin                : Mon Feb 5 2001 by Tim Colgate
    copyright            : (C) 2001 Tim Colgate

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *

 ***************************************************************************/

#ifndef LOGIN_DLG_H
#define LOGIN_DLG_H

#include <vector>
#include <string>
#include <map>
using namespace std;

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qdialog.h>


class LoginDlg : public QDialog  {
   Q_OBJECT
public:
	LoginDlg(QWidget *parent, const QString& server_, const QString& database_, string& username_, string& password_, map<string, string>& logins_);
	~LoginDlg() {}

private:
	QPushButton* btnCancel;
	QPushButton* btnExec;

	QCheckBox* chkDatabase;
	QCheckBox* chkServer;

	QLabel* lblMain;
	QLabel* lblUsername;
	QLabel* lblPassword;

	QLineEdit* edtUsername;
	QLineEdit* edtPassword;

	const QString& server;
	const QString& database;
	string& username;
	string& password;
	map<string, string>& logins;

public slots:
	void ok_pressed();
};

#endif
