/***************************************************************************
                          sproc_dlg.cpp  -  description
                             -------------------
    begin                : Mon Feb 5 2001 by Tim Colgate
    copyright            : (C) 2001 Tim Colgate

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *

 ***************************************************************************/

#include <iostream>
#include <string>
using namespace std ;

#include <stdlib.h>	// getenv

#include <qmessagebox.h>
#include <qtooltip.h>

#include "sproc_dlg.h"


SProcDlg::SProcDlg(QWidget *parent, const string& sproc_name_, vector<SProcParam>& params_) : QDialog(parent, NULL, true), sproc_name(sproc_name_), params(params_)
{
	this->resize(480, params.size()*30 + 70);
//	this->setMinimumSize(0,0);
	this->setCaption(sproc_name.c_str());

	int i;
	QLabel* lbl;
	QLineEdit* edt;
	for (i=0; i < params.size(); i++) {
		lbl = new QLabel(params[i].name.c_str(), this);
		lbl->setGeometry(10, 10 + i*30, 150, 25);
		lblNames.push_back(lbl);
		lbl = new QLabel(params[i].type.c_str(), this);
		lbl->setGeometry(170, 10 + i*30, 80, 25);
		lblTypes.push_back(lbl);
		edt = new QLineEdit(params[i].value.c_str(), this);
		edt->setGeometry(260, 10 + i*30, 210, 25);
		if (i==0) edt->setFocus();
		edits.push_back(edt);
	}
	
	if (i != 0) {
		btnClear= new QPushButton("Clear Values", this);
		btnClear->setGeometry(40, 30 + i*30, 100, 30);
		QToolTip::add(btnClear, "Clear all parameter values");
		connect(btnClear, SIGNAL(clicked()), this, SLOT(clearValues()));
	}
	
	btnCancel= new QPushButton("Cancel", this);
	btnCancel->setGeometry(190, 30 + i*30, 100, 30);
	
	btnExec= new QPushButton("Execute", this);
	btnExec->setGeometry(340, 30 + i*30, 100, 30);
	btnExec->setDefault(true);
	
	connect(btnCancel, SIGNAL(clicked()), this, SLOT(reject()));
	connect(btnExec, SIGNAL(clicked()), this, SLOT(accept()));
}

void SProcDlg::clearValues()
{
	for (int i=0; i < edits.size(); i++)
		edits[i]->clear();
}

string SProcDlg::getSQL()
{
//	string sql = "exec " + sproc_name + " ";
	string sql = sproc_name + " ";
	
	for (int i=0; i < params.size(); i++) {
		params[i].value = (const char*)(edits[i]->text());

		if (i > 0) sql += ',';		
		if (params[i].type == "char" && params[i].value != "NULL" && params[i].value != "null")
			sql += string("'") + params[i].value + "'";
		else
			sql += params[i].value;
	}
	
	return sql;
}
