/***************************************************************************
                          sproc_dlg.h  -  description
                             -------------------
    begin                : Mon Feb 5 2001 by Tim Colgate
    copyright            : (C) 2001 Tim Colgate

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *

 ***************************************************************************/

#ifndef SPROC_DLG_H
#define SPROC_DLG_H

#include <vector>
#include <string>
using namespace std ;

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qdialog.h>

struct SProcParam {
	SProcParam(string name_, string type_):name(name_), type(type_) {}

	string name;
	string type;
	string value;
};


class SProcDlg : public QDialog  {
   Q_OBJECT
public:
	SProcDlg(QWidget *parent, const string& sproc_name_, vector<SProcParam>& params_);
	~SProcDlg() {}

	string getSQL();

private:
	QPushButton *btnClear;
	QPushButton *btnCancel;
	QPushButton *btnExec;

	const string& sproc_name;
	vector<SProcParam>& params;

	vector<QLabel*> lblNames;
	vector<QLabel*> lblTypes;
	vector<QLineEdit*> edits;

public slots:
	void clearValues();
};

#endif
